import { CSSObject } from "cxs";
export declare type DynamicProps<T> = {
    [key in keyof T]?: (props?: Record<string, string | number>) => string;
};
export declare type GetUnionClassNames<T> = (...keyClassNames: Array<T | boolean>) => string;
export declare type GetObjectClassNames<T> = (keyClassNames: {
    [key in keyof T]?: boolean;
}) => string;
export declare type ItemClassName<T> = {
    [key in keyof T]: CSSObject | string;
};
export declare type GetDynamicClassnames<T, K extends keyof T> = Record<K, (e?: any) => CSSObject | string>;
export declare type GetPropMethod<T> = T extends (args: infer U) => void ? Partial<U> : any;
export declare type GetDynamicCallbackProps<T, K extends keyof T> = (args: {
    [key in K]?: GetPropMethod<T> | boolean;
}) => string;
export interface IFlyJSS {
    create<T, K extends keyof T>(classes: ItemClassName<T>): GetUnionClassNames<K> & GetObjectClassNames<T>;
    createDynamic<T, K extends keyof T>(classes: GetDynamicClassnames<T, K>): GetDynamicCallbackProps<T, K>;
    compose(...styles: string[]): string;
}
